/* Auto-generated private header file */

/* This file should be included by the IMPLEMENTOR of the hook interface
 * It is not required by USERS of the hook interface
 */

#ifndef JITHOOK_INTERNAL_H
#define JITHOOK_INTERNAL_H

#include "jithook.h"

#define ALWAYS_TRIGGER_J9HOOK_JIT_COMPILED_METHOD_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_metaData) \
	do { \
		struct J9CompiledMethodLoadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.startPC = (arg_startPC); \
		eventData.length = (arg_length); \
		eventData.metaData = (arg_metaData); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_JIT_COMPILED_METHOD_LOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_JIT_COMPILED_METHOD_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_metaData) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_JIT_COMPILED_METHOD_LOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_JIT_COMPILED_METHOD_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_metaData); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_JIT_COMPILED_METHOD_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_metaData) \
	do { \
		struct J9CompiledMethodUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.startPC = (arg_startPC); \
		eventData.length = (arg_length); \
		eventData.metaData = (arg_metaData); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_JIT_COMPILED_METHOD_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_JIT_COMPILED_METHOD_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_metaData) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_JIT_COMPILED_METHOD_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_JIT_COMPILED_METHOD_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_metaData); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_JIT_COMPILING_START(hookInterface, arg_currentThread, arg_method) \
	do { \
		struct J9CompilingStartEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_JIT_COMPILING_START, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_JIT_COMPILING_START(hookInterface, arg_currentThread, arg_method) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_JIT_COMPILING_START)) { \
			ALWAYS_TRIGGER_J9HOOK_JIT_COMPILING_START(hookInterface, arg_currentThread, arg_method); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_JIT_COMPILING_END(hookInterface, arg_currentThread, arg_method) \
	do { \
		struct J9CompilingEndEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_JIT_COMPILING_END, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_JIT_COMPILING_END(hookInterface, arg_currentThread, arg_method) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_JIT_COMPILING_END)) { \
			ALWAYS_TRIGGER_J9HOOK_JIT_COMPILING_END(hookInterface, arg_currentThread, arg_method); \
		} \
	} while (0)

#if defined (J9VM_JIT_FULL_SPEED_DEBUG)
#define ALWAYS_TRIGGER_J9HOOK_JIT_CHECK_FOR_DATA_BREAKPOINT(hookInterface, arg_currentThread, arg_result, arg_fieldIndex, arg_constantPool, arg_resolvedField, arg_isStatic, arg_isStore) \
	do { \
		struct J9CheckForDataBreakpointEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.result = (arg_result); \
		eventData.fieldIndex = (arg_fieldIndex); \
		eventData.constantPool = (arg_constantPool); \
		eventData.resolvedField = (arg_resolvedField); \
		eventData.isStatic = (arg_isStatic); \
		eventData.isStore = (arg_isStore); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_JIT_CHECK_FOR_DATA_BREAKPOINT, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_JIT_CHECK_FOR_DATA_BREAKPOINT(hookInterface, arg_currentThread, arg_result, arg_fieldIndex, arg_constantPool, arg_resolvedField, arg_isStatic, arg_isStore) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_JIT_CHECK_FOR_DATA_BREAKPOINT)) { \
			ALWAYS_TRIGGER_J9HOOK_JIT_CHECK_FOR_DATA_BREAKPOINT(hookInterface, arg_currentThread, arg_result, arg_fieldIndex, arg_constantPool, arg_resolvedField, arg_isStatic, arg_isStore); \
		} \
	} while (0)
#else /* defined (J9VM_JIT_FULL_SPEED_DEBUG) */
#define TRIGGER_J9HOOK_JIT_CHECK_FOR_DATA_BREAKPOINT(hookInterface, arg_currentThread, arg_result, arg_fieldIndex, arg_constantPool, arg_resolvedField, arg_isStatic, arg_isStore)
#endif /* defined (J9VM_JIT_FULL_SPEED_DEBUG) */

typedef struct J9JITHookInterface {
	struct J9CommonHookInterface common;
	U_8 flags[6];
	struct OMREventInfo4Dump infos4Dump[6];
	J9HookRecord* hooks[6];
} J9JITHookInterface;

#endif /* JITHOOK_INTERNAL_H */
