/* Auto-generated private header file */

/* This file should be included by the IMPLEMENTOR of the hook interface
 * It is not required by USERS of the hook interface
 */

#ifndef VMHOOK_INTERNAL_H
#define VMHOOK_INTERNAL_H

#include "vmhook.h"

#define ALWAYS_TRIGGER_J9HOOK_THREAD_ABOUT_TO_START(hookInterface, arg_vmThread) \
	do { \
		struct J9ThreadAboutToStartEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_THREAD_ABOUT_TO_START, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_THREAD_ABOUT_TO_START(hookInterface, arg_vmThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_THREAD_ABOUT_TO_START)) { \
			ALWAYS_TRIGGER_J9HOOK_THREAD_ABOUT_TO_START(hookInterface, arg_vmThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZED(hookInterface, arg_vmThread) \
	do { \
		struct J9VMInitEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_INITIALIZED | J9HOOK_TAG_ONCE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_INITIALIZED(hookInterface, arg_vmThread) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZED(hookInterface, arg_vmThread); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SHUTTING_DOWN(hookInterface, arg_vmThread, arg_exitCode) \
	do { \
		struct J9VMShutdownEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		eventData.exitCode = (arg_exitCode); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SHUTTING_DOWN | J9HOOK_TAG_ONCE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_SHUTTING_DOWN(hookInterface, arg_vmThread, arg_exitCode) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_VM_SHUTTING_DOWN(hookInterface, arg_vmThread, arg_exitCode); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_THREAD_STARTING(hookInterface, arg_currentThread, arg_startedThread) \
	do { \
		struct J9VMThreadStartingEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.startedThread = (arg_startedThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_THREAD_STARTING, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_THREAD_STARTING(hookInterface, arg_currentThread, arg_startedThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_THREAD_STARTING)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_THREAD_STARTING(hookInterface, arg_currentThread, arg_startedThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_THREAD_CREATED(hookInterface, arg_vmThread, arg_continueInitialization) \
	do { \
		struct J9VMThreadCreatedEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		eventData.continueInitialization = (arg_continueInitialization); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_THREAD_CREATED, &eventData); \
		(arg_continueInitialization) = eventData.continueInitialization; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_THREAD_CREATED(hookInterface, arg_vmThread, arg_continueInitialization) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_THREAD_CREATED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_THREAD_CREATED(hookInterface, arg_vmThread, arg_continueInitialization); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_THREAD_DESTROY(hookInterface, arg_vmThread) \
	do { \
		struct J9VMThreadDestroyEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_THREAD_DESTROY, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_THREAD_DESTROY(hookInterface, arg_vmThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_THREAD_DESTROY)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_THREAD_DESTROY(hookInterface, arg_vmThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_THREAD_STARTED(hookInterface, arg_currentThread, arg_vmThread) \
	do { \
		struct J9VMThreadStartedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_THREAD_STARTED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_THREAD_STARTED(hookInterface, arg_currentThread, arg_vmThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_THREAD_STARTED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_THREAD_STARTED(hookInterface, arg_currentThread, arg_vmThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_THREAD_END(hookInterface, arg_currentThread, arg_destroyingJavaVM) \
	do { \
		struct J9VMThreadEndEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.destroyingJavaVM = (arg_destroyingJavaVM); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_THREAD_END, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_THREAD_END(hookInterface, arg_currentThread, arg_destroyingJavaVM) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_THREAD_END)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_THREAD_END(hookInterface, arg_currentThread, arg_destroyingJavaVM); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOAD(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		struct J9VMClassLoadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOAD(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOAD(hookInterface, arg_currentThread, arg_clazz); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_THROW(hookInterface, arg_currentThread, arg_exception) \
	do { \
		struct J9VMExceptionThrowEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.exception = (arg_exception); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_EXCEPTION_THROW, &eventData); \
		(arg_exception) = eventData.exception; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_EXCEPTION_THROW(hookInterface, arg_currentThread, arg_exception) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_EXCEPTION_THROW)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_THROW(hookInterface, arg_currentThread, arg_exception); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_SYSTHROW(hookInterface, arg_currentThread, arg_exception) \
	do { \
		struct J9VMExceptionSysThrowEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.exception = (arg_exception); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_EXCEPTION_SYSTHROW, &eventData); \
		(arg_exception) = eventData.exception; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_EXCEPTION_SYSTHROW(hookInterface, arg_currentThread, arg_exception) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_EXCEPTION_SYSTHROW)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_SYSTHROW(hookInterface, arg_currentThread, arg_exception); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_CATCH(hookInterface, arg_currentThread, arg_exception, arg_popProtectedFrame) \
	do { \
		struct J9VMExceptionCatchEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.exception = (arg_exception); \
		eventData.popProtectedFrame = (arg_popProtectedFrame); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_EXCEPTION_CATCH, &eventData); \
		(arg_exception) = eventData.exception; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_EXCEPTION_CATCH(hookInterface, arg_currentThread, arg_exception, arg_popProtectedFrame) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_EXCEPTION_CATCH)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_CATCH(hookInterface, arg_currentThread, arg_exception, arg_popProtectedFrame); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_BREAKPOINT(hookInterface, arg_currentThread, arg_method, arg_location, arg_originalBytecode) \
	do { \
		struct J9VMBreakpointEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.location = (arg_location); \
		eventData.originalBytecode = (arg_originalBytecode); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_BREAKPOINT, &eventData); \
		(arg_originalBytecode) = eventData.originalBytecode; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_BREAKPOINT(hookInterface, arg_currentThread, arg_method, arg_location, arg_originalBytecode) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_BREAKPOINT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_BREAKPOINT(hookInterface, arg_currentThread, arg_method, arg_location, arg_originalBytecode); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_FRAME_POPPED(hookInterface, arg_currentThread) \
	do { \
		struct J9VMFramePoppedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FRAME_POPPED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_FRAME_POPPED(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FRAME_POPPED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FRAME_POPPED(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_ENTER(hookInterface, arg_currentThread, arg_monitor) \
	do { \
		struct J9VMMonitorContendedEnterEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.monitor = (arg_monitor); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MONITOR_CONTENDED_ENTER, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_ENTER(hookInterface, arg_currentThread, arg_monitor) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MONITOR_CONTENDED_ENTER)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_ENTER(hookInterface, arg_currentThread, arg_monitor); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_ENTERED(hookInterface, arg_currentThread, arg_monitor, arg_startTicks, arg_monitorClass, arg_previousOwner) \
	do { \
		struct J9VMMonitorContendedEnteredEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.monitor = (arg_monitor); \
		eventData.startTicks = (arg_startTicks); \
		eventData.monitorClass = (arg_monitorClass); \
		eventData.previousOwner = (arg_previousOwner); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MONITOR_CONTENDED_ENTERED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_ENTERED(hookInterface, arg_currentThread, arg_monitor, arg_startTicks, arg_monitorClass, arg_previousOwner) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MONITOR_CONTENDED_ENTERED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_ENTERED(hookInterface, arg_currentThread, arg_monitor, arg_startTicks, arg_monitorClass, arg_previousOwner); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_DESCRIBE(hookInterface, arg_currentThread, arg_exception) \
	do { \
		struct J9VMExceptionDescribeEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.exception = (arg_exception); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_EXCEPTION_DESCRIBE, &eventData); \
		(arg_exception) = eventData.exception; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_EXCEPTION_DESCRIBE(hookInterface, arg_currentThread, arg_exception) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_EXCEPTION_DESCRIBE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_EXCEPTION_DESCRIBE(hookInterface, arg_currentThread, arg_exception); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_GETENV(hookInterface, arg_jvm, arg_penv, arg_version, arg_rc) \
	do { \
		struct J9VMGetEnvEvent eventData; \
		eventData.jvm = (arg_jvm); \
		eventData.penv = (arg_penv); \
		eventData.version = (arg_version); \
		eventData.rc = (arg_rc); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_GETENV, &eventData); \
		(arg_rc) = eventData.rc; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_GETENV(hookInterface, arg_jvm, arg_penv, arg_version, arg_rc) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_GETENV)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_GETENV(hookInterface, arg_jvm, arg_penv, arg_version, arg_rc); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SLOW_EXCLUSIVE(hookInterface, arg_currentThread, arg_timeTaken, arg_reason) \
	do { \
		struct J9VMSlowExclusiveEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.timeTaken = (arg_timeTaken); \
		eventData.reason = (arg_reason); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SLOW_EXCLUSIVE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_SLOW_EXCLUSIVE(hookInterface, arg_currentThread, arg_timeTaken, arg_reason) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_SLOW_EXCLUSIVE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_SLOW_EXCLUSIVE(hookInterface, arg_currentThread, arg_timeTaken, arg_reason); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_ACQUIREVMACCESS(hookInterface, arg_currentThread) \
	do { \
		struct J9VMAcquireVMAccessEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_ACQUIREVMACCESS, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_ACQUIREVMACCESS(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_ACQUIREVMACCESS)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_ACQUIREVMACCESS(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_RELEASEVMACCESS(hookInterface, arg_currentThread) \
	do { \
		struct J9VMReleaseVMAccessEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_RELEASEVMACCESS, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_RELEASEVMACCESS(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_RELEASEVMACCESS)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_RELEASEVMACCESS(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_ACQUIRING_EXCLUSIVE_IN_NATIVE(hookInterface, arg_currentThread, arg_targetThread) \
	do { \
		struct J9VMAcquringExclusiveInNativeEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.targetThread = (arg_targetThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_ACQUIRING_EXCLUSIVE_IN_NATIVE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_ACQUIRING_EXCLUSIVE_IN_NATIVE(hookInterface, arg_currentThread, arg_targetThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_ACQUIRING_EXCLUSIVE_IN_NATIVE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_ACQUIRING_EXCLUSIVE_IN_NATIVE(hookInterface, arg_currentThread, arg_targetThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_THREAD_CRASH(hookInterface, arg_currentThread) \
	do { \
		struct J9VMThreadCrashEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_THREAD_CRASH, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_THREAD_CRASH(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_THREAD_CRASH)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_THREAD_CRASH(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_METHOD_ENTER(hookInterface, arg_currentThread, arg_method, arg_arg0EA, arg_methodType) \
	do { \
		struct J9VMMethodEnterEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.arg0EA = (arg_arg0EA); \
		eventData.methodType = (arg_methodType); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_METHOD_ENTER, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_METHOD_ENTER(hookInterface, arg_currentThread, arg_method, arg_arg0EA, arg_methodType) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_METHOD_ENTER)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_METHOD_ENTER(hookInterface, arg_currentThread, arg_method, arg_arg0EA, arg_methodType); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_ABOUT_TO_BOOTSTRAP(hookInterface, arg_currentThread) \
	do { \
		struct J9VMAboutToBootstrapEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_ABOUT_TO_BOOTSTRAP | J9HOOK_TAG_ONCE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_ABOUT_TO_BOOTSTRAP(hookInterface, arg_currentThread) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_VM_ABOUT_TO_BOOTSTRAP(hookInterface, arg_currentThread); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_METHOD_RETURN(hookInterface, arg_currentThread, arg_method, arg_poppedByException, arg_returnValuePtr, arg_methodType) \
	do { \
		struct J9VMMethodReturnEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.poppedByException = (arg_poppedByException); \
		eventData.returnValuePtr = (arg_returnValuePtr); \
		eventData.methodType = (arg_methodType); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_METHOD_RETURN, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_METHOD_RETURN(hookInterface, arg_currentThread, arg_method, arg_poppedByException, arg_returnValuePtr, arg_methodType) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_METHOD_RETURN)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_METHOD_RETURN(hookInterface, arg_currentThread, arg_method, arg_poppedByException, arg_returnValuePtr, arg_methodType); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_NATIVE_METHOD_ENTER(hookInterface, arg_currentThread, arg_method, arg_arg0EA) \
	do { \
		struct J9VMNativeMethodEnterEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.arg0EA = (arg_arg0EA); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_NATIVE_METHOD_ENTER, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_NATIVE_METHOD_ENTER(hookInterface, arg_currentThread, arg_method, arg_arg0EA) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_NATIVE_METHOD_ENTER)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_NATIVE_METHOD_ENTER(hookInterface, arg_currentThread, arg_method, arg_arg0EA); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_NATIVE_METHOD_RETURN(hookInterface, arg_currentThread, arg_method, arg_poppedByException, arg_returnValuePtr, arg_returnRef) \
	do { \
		struct J9VMNativeMethodReturnEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.poppedByException = (arg_poppedByException); \
		eventData.returnValuePtr = (arg_returnValuePtr); \
		eventData.returnRef = (arg_returnRef); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_NATIVE_METHOD_RETURN, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_NATIVE_METHOD_RETURN(hookInterface, arg_currentThread, arg_method, arg_poppedByException, arg_returnValuePtr, arg_returnRef) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_NATIVE_METHOD_RETURN)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_NATIVE_METHOD_RETURN(hookInterface, arg_currentThread, arg_method, arg_poppedByException, arg_returnValuePtr, arg_returnRef); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_ROM_CLASS_LOAD(hookInterface, arg_currentThread, arg_romClass) \
	do { \
		struct J9VMROMClassLoadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.romClass = (arg_romClass); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_ROM_CLASS_LOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_ROM_CLASS_LOAD(hookInterface, arg_currentThread, arg_romClass) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_ROM_CLASS_LOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_ROM_CLASS_LOAD(hookInterface, arg_currentThread, arg_romClass); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_EXIT(hookInterface, arg_currentThread, arg_monitor) \
	do { \
		struct J9VMMonitorContendedExitEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.monitor = (arg_monitor); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MONITOR_CONTENDED_EXIT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_EXIT(hookInterface, arg_currentThread, arg_monitor) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MONITOR_CONTENDED_EXIT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_CONTENDED_EXIT(hookInterface, arg_currentThread, arg_monitor); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOAD_HOOK(hookInterface, arg_currentThread, arg_classLoader, arg_protectionDomain, arg_oldClass, arg_className, arg_classData, arg_classDataLength, arg_freeUserData, arg_freeFunction, arg_classDataReplaced) \
	do { \
		struct J9VMClassLoadHookEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classLoader = (arg_classLoader); \
		eventData.protectionDomain = (arg_protectionDomain); \
		eventData.oldClass = (arg_oldClass); \
		eventData.className = (arg_className); \
		eventData.classData = (arg_classData); \
		eventData.classDataLength = (arg_classDataLength); \
		eventData.freeUserData = (arg_freeUserData); \
		eventData.freeFunction = (arg_freeFunction); \
		eventData.classDataReplaced = (arg_classDataReplaced); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOAD_HOOK, &eventData); \
		(arg_protectionDomain) = eventData.protectionDomain; /* return argument */ \
		(arg_classData) = eventData.classData; /* return argument */ \
		(arg_classDataLength) = eventData.classDataLength; /* return argument */ \
		(arg_freeUserData) = eventData.freeUserData; /* return argument */ \
		(arg_freeFunction) = eventData.freeFunction; /* return argument */ \
		(arg_classDataReplaced) = eventData.classDataReplaced; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOAD_HOOK(hookInterface, arg_currentThread, arg_classLoader, arg_protectionDomain, arg_oldClass, arg_className, arg_classData, arg_classDataLength, arg_freeUserData, arg_freeFunction, arg_classDataReplaced) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOAD_HOOK)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOAD_HOOK(hookInterface, arg_currentThread, arg_classLoader, arg_protectionDomain, arg_oldClass, arg_className, arg_classData, arg_classDataLength, arg_freeUserData, arg_freeFunction, arg_classDataReplaced); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOAD_HOOK2(hookInterface, arg_currentThread, arg_classLoader, arg_protectionDomain, arg_oldClass, arg_className, arg_classData, arg_classDataLength, arg_freeUserData, arg_freeFunction, arg_classDataReplaced) \
	do { \
		struct J9VMClassLoadHook2Event eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classLoader = (arg_classLoader); \
		eventData.protectionDomain = (arg_protectionDomain); \
		eventData.oldClass = (arg_oldClass); \
		eventData.className = (arg_className); \
		eventData.classData = (arg_classData); \
		eventData.classDataLength = (arg_classDataLength); \
		eventData.freeUserData = (arg_freeUserData); \
		eventData.freeFunction = (arg_freeFunction); \
		eventData.classDataReplaced = (arg_classDataReplaced); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOAD_HOOK2, &eventData); \
		(arg_protectionDomain) = eventData.protectionDomain; /* return argument */ \
		(arg_classData) = eventData.classData; /* return argument */ \
		(arg_classDataLength) = eventData.classDataLength; /* return argument */ \
		(arg_freeUserData) = eventData.freeUserData; /* return argument */ \
		(arg_freeFunction) = eventData.freeFunction; /* return argument */ \
		(arg_classDataReplaced) = eventData.classDataReplaced; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOAD_HOOK2(hookInterface, arg_currentThread, arg_classLoader, arg_protectionDomain, arg_oldClass, arg_className, arg_classData, arg_classDataLength, arg_freeUserData, arg_freeFunction, arg_classDataReplaced) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOAD_HOOK2)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOAD_HOOK2(hookInterface, arg_currentThread, arg_classLoader, arg_protectionDomain, arg_oldClass, arg_className, arg_classData, arg_classDataLength, arg_freeUserData, arg_freeFunction, arg_classDataReplaced); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE(hookInterface, arg_currentThread, arg_object, arg_size) \
	do { \
		struct J9VMObjectAllocateEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.object = (arg_object); \
		eventData.size = (arg_size); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_OBJECT_ALLOCATE, &eventData); \
		(arg_object) = eventData.object; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE(hookInterface, arg_currentThread, arg_object, arg_size) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_OBJECT_ALLOCATE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE(hookInterface, arg_currentThread, arg_object, arg_size); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE_INSTRUMENTABLE(hookInterface, arg_currentThread, arg_object, arg_size) \
	do { \
		struct J9VMObjectAllocateInstrumentableEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.object = (arg_object); \
		eventData.size = (arg_size); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_OBJECT_ALLOCATE_INSTRUMENTABLE, &eventData); \
		(arg_object) = eventData.object; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE_INSTRUMENTABLE(hookInterface, arg_currentThread, arg_object, arg_size) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_OBJECT_ALLOCATE_INSTRUMENTABLE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE_INSTRUMENTABLE(hookInterface, arg_currentThread, arg_object, arg_size); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_USER_INTERRUPT(hookInterface, arg_vm) \
	do { \
		struct J9VMUserInterruptEvent eventData; \
		eventData.vm = (arg_vm); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_USER_INTERRUPT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_USER_INTERRUPT(hookInterface, arg_vm) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_USER_INTERRUPT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_USER_INTERRUPT(hookInterface, arg_vm); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZE_SEND_TARGET(hookInterface, arg_currentThread, arg_method) \
	do { \
		struct J9VMInitializeSendTargetEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_INITIALIZE_SEND_TARGET | 16711680, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_INITIALIZE_SEND_TARGET(hookInterface, arg_currentThread, arg_method) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_INITIALIZE_SEND_TARGET)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZE_SEND_TARGET(hookInterface, arg_currentThread, arg_method); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_WAIT(hookInterface, arg_currentThread, arg_monitor, arg_millis, arg_nanos) \
	do { \
		struct J9VMMonitorWaitEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.monitor = (arg_monitor); \
		eventData.millis = (arg_millis); \
		eventData.nanos = (arg_nanos); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MONITOR_WAIT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MONITOR_WAIT(hookInterface, arg_currentThread, arg_monitor, arg_millis, arg_nanos) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MONITOR_WAIT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_WAIT(hookInterface, arg_currentThread, arg_monitor, arg_millis, arg_nanos); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_WAITED(hookInterface, arg_currentThread, arg_monitor, arg_millis, arg_nanos, arg_reason, arg_startTicks, arg_monitorAddress, arg_monitorClass) \
	do { \
		struct J9VMMonitorWaitedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.monitor = (arg_monitor); \
		eventData.millis = (arg_millis); \
		eventData.nanos = (arg_nanos); \
		eventData.reason = (arg_reason); \
		eventData.startTicks = (arg_startTicks); \
		eventData.monitorAddress = (arg_monitorAddress); \
		eventData.monitorClass = (arg_monitorClass); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MONITOR_WAITED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MONITOR_WAITED(hookInterface, arg_currentThread, arg_monitor, arg_millis, arg_nanos, arg_reason, arg_startTicks, arg_monitorAddress, arg_monitorClass) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MONITOR_WAITED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MONITOR_WAITED(hookInterface, arg_currentThread, arg_monitor, arg_millis, arg_nanos, arg_reason, arg_startTicks, arg_monitorAddress, arg_monitorClass); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_STARTED(hookInterface, arg_vmThread) \
	do { \
		struct J9VMStartEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_STARTED | J9HOOK_TAG_ONCE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_STARTED(hookInterface, arg_vmThread) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_VM_STARTED(hookInterface, arg_vmThread); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_REQUIRED_DEBUG_ATTRIBUTES(hookInterface, arg_vmThread, arg_requiredDebugAttributes) \
	do { \
		struct J9VMRequiredDebugAttributesEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		eventData.requiredDebugAttributes = (arg_requiredDebugAttributes); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_REQUIRED_DEBUG_ATTRIBUTES | J9HOOK_TAG_ONCE, &eventData); \
		(arg_requiredDebugAttributes) = eventData.requiredDebugAttributes; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_REQUIRED_DEBUG_ATTRIBUTES(hookInterface, arg_vmThread, arg_requiredDebugAttributes) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_VM_REQUIRED_DEBUG_ATTRIBUTES(hookInterface, arg_vmThread, arg_requiredDebugAttributes); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_PREPARE(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		struct J9VMClassPrepareEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_PREPARE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_PREPARE(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_PREPARE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_PREPARE(hookInterface, arg_currentThread, arg_clazz); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_FIND_METHOD_FROM_PC(hookInterface, arg_currentThread, arg_pc, arg_clazz, arg_result) \
	do { \
		struct J9VMFindMethodFromPCEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.pc = (arg_pc); \
		eventData.clazz = (arg_clazz); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FIND_METHOD_FROM_PC, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_FIND_METHOD_FROM_PC(hookInterface, arg_currentThread, arg_pc, arg_clazz, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FIND_METHOD_FROM_PC)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FIND_METHOD_FROM_PC(hookInterface, arg_currentThread, arg_pc, arg_clazz, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_PERMANENT_PC(hookInterface, arg_currentThread, arg_pc) \
	do { \
		struct J9VMPermanentPCEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.pc = (arg_pc); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PERMANENT_PC, &eventData); \
		(arg_pc) = eventData.pc; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_PERMANENT_PC(hookInterface, arg_currentThread, arg_pc) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PERMANENT_PC)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PERMANENT_PC(hookInterface, arg_currentThread, arg_pc); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_PARK(hookInterface, arg_currentThread, arg_millis, arg_nanos) \
	do { \
		struct J9VMParkEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.millis = (arg_millis); \
		eventData.nanos = (arg_nanos); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PARK, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_PARK(hookInterface, arg_currentThread, arg_millis, arg_nanos) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PARK)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PARK(hookInterface, arg_currentThread, arg_millis, arg_nanos); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_UNPARKED(hookInterface, arg_currentThread, arg_millis, arg_nanos, arg_startTicks, arg_parkedAddress, arg_parkedClass) \
	do { \
		struct J9VMUnparkedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.millis = (arg_millis); \
		eventData.nanos = (arg_nanos); \
		eventData.startTicks = (arg_startTicks); \
		eventData.parkedAddress = (arg_parkedAddress); \
		eventData.parkedClass = (arg_parkedClass); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_UNPARKED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_UNPARKED(hookInterface, arg_currentThread, arg_millis, arg_nanos, arg_startTicks, arg_parkedAddress, arg_parkedClass) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_UNPARKED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_UNPARKED(hookInterface, arg_currentThread, arg_millis, arg_nanos, arg_startTicks, arg_parkedAddress, arg_parkedClass); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_GET_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_object, arg_offset) \
	do { \
		struct J9VMGetFieldEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.location = (arg_location); \
		eventData.object = (arg_object); \
		eventData.offset = (arg_offset); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_GET_FIELD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_GET_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_object, arg_offset) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_GET_FIELD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_GET_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_object, arg_offset); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_PUT_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_object, arg_offset, arg_newValue) \
	do { \
		struct J9VMPutFieldEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.location = (arg_location); \
		eventData.object = (arg_object); \
		eventData.offset = (arg_offset); \
		eventData.newValue = (arg_newValue); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PUT_FIELD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_PUT_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_object, arg_offset, arg_newValue) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PUT_FIELD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PUT_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_object, arg_offset, arg_newValue); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_GET_STATIC_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_declaringClass, arg_fieldAddress) \
	do { \
		struct J9VMGetStaticFieldEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.location = (arg_location); \
		eventData.declaringClass = (arg_declaringClass); \
		eventData.fieldAddress = (arg_fieldAddress); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_GET_STATIC_FIELD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_GET_STATIC_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_declaringClass, arg_fieldAddress) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_GET_STATIC_FIELD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_GET_STATIC_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_declaringClass, arg_fieldAddress); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_PUT_STATIC_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_declaringClass, arg_fieldAddress, arg_newValue) \
	do { \
		struct J9VMPutStaticFieldEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.location = (arg_location); \
		eventData.declaringClass = (arg_declaringClass); \
		eventData.fieldAddress = (arg_fieldAddress); \
		eventData.newValue = (arg_newValue); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PUT_STATIC_FIELD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_PUT_STATIC_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_declaringClass, arg_fieldAddress, arg_newValue) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PUT_STATIC_FIELD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PUT_STATIC_FIELD(hookInterface, arg_currentThread, arg_method, arg_location, arg_declaringClass, arg_fieldAddress, arg_newValue); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SINGLE_STEP(hookInterface, arg_currentThread, arg_method, arg_location) \
	do { \
		struct J9VMSingleStepEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.location = (arg_location); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SINGLE_STEP, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_SINGLE_STEP(hookInterface, arg_currentThread, arg_method, arg_location) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_SINGLE_STEP)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_SINGLE_STEP(hookInterface, arg_currentThread, arg_method, arg_location); \
		} \
	} while (0)

#if defined (J9VM_INTERP_PROFILING_BYTECODES)
#define ALWAYS_TRIGGER_J9HOOK_VM_PROFILING_BYTECODE_BUFFER_FULL(hookInterface, arg_currentThread, arg_bufferStart, arg_bufferSize) \
	do { \
		struct J9VMProfilingBytecodeBufferFullEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.bufferStart = (arg_bufferStart); \
		eventData.bufferSize = (arg_bufferSize); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PROFILING_BYTECODE_BUFFER_FULL | 16711680, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_PROFILING_BYTECODE_BUFFER_FULL(hookInterface, arg_currentThread, arg_bufferStart, arg_bufferSize) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PROFILING_BYTECODE_BUFFER_FULL)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PROFILING_BYTECODE_BUFFER_FULL(hookInterface, arg_currentThread, arg_bufferStart, arg_bufferSize); \
		} \
	} while (0)
#else /* defined (J9VM_INTERP_PROFILING_BYTECODES) */
#define TRIGGER_J9HOOK_VM_PROFILING_BYTECODE_BUFFER_FULL(hookInterface, arg_currentThread, arg_bufferStart, arg_bufferSize)
#endif /* defined (J9VM_INTERP_PROFILING_BYTECODES) */

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_PREINITIALIZE(hookInterface, arg_currentThread, arg_clazz, arg_failed) \
	do { \
		struct J9VMClassPreinitializeEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		eventData.failed = (arg_failed); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_PREINITIALIZE, &eventData); \
		(arg_failed) = eventData.failed; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_PREINITIALIZE(hookInterface, arg_currentThread, arg_clazz, arg_failed) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_PREINITIALIZE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_PREINITIALIZE(hookInterface, arg_currentThread, arg_clazz, arg_failed); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_INITIALIZE(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		struct J9VMClassInitializeEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_INITIALIZE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_INITIALIZE(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_INITIALIZE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_INITIALIZE(hookInterface, arg_currentThread, arg_clazz); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_INITIALIZE_FAILED(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		struct J9VMClassInitializeFailedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_INITIALIZE_FAILED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_INITIALIZE_FAILED(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_INITIALIZE_FAILED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_INITIALIZE_FAILED(hookInterface, arg_currentThread, arg_clazz); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_INITIALIZED(hookInterface, arg_vmThread, arg_classLoader) \
	do { \
		struct J9VMClassLoaderInitializedEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		eventData.classLoader = (arg_classLoader); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADER_INITIALIZED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADER_INITIALIZED(hookInterface, arg_vmThread, arg_classLoader) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADER_INITIALIZED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_INITIALIZED(hookInterface, arg_vmThread, arg_classLoader); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_LOOKUP_JNI_ID(hookInterface, arg_currentThread, arg_clazz, arg_name, arg_signature, arg_isStatic, arg_isField, arg_id) \
	do { \
		struct J9VMLookupJNIIDEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		eventData.name = (arg_name); \
		eventData.signature = (arg_signature); \
		eventData.isStatic = (arg_isStatic); \
		eventData.isField = (arg_isField); \
		eventData.id = (arg_id); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_LOOKUP_JNI_ID, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_LOOKUP_JNI_ID(hookInterface, arg_currentThread, arg_clazz, arg_name, arg_signature, arg_isStatic, arg_isField, arg_id) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_LOOKUP_JNI_ID)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_LOOKUP_JNI_ID(hookInterface, arg_currentThread, arg_clazz, arg_name, arg_signature, arg_isStatic, arg_isField, arg_id); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS(hookInterface, arg_currentThread, arg_classloader, arg_j9module, arg_className, arg_classNameLength, arg_classPathEntries, arg_entryCount, arg_confirmedCount, arg_partition, arg_doPreventFind, arg_doPreventStore, arg_foundAtIndex, arg_result) \
	do { \
		struct J9VMFindLocalClassEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classloader = (arg_classloader); \
		eventData.j9module = (arg_j9module); \
		eventData.className = (arg_className); \
		eventData.classNameLength = (arg_classNameLength); \
		eventData.classPathEntries = (arg_classPathEntries); \
		eventData.entryCount = (arg_entryCount); \
		eventData.confirmedCount = (arg_confirmedCount); \
		eventData.partition = (arg_partition); \
		eventData.doPreventFind = (arg_doPreventFind); \
		eventData.doPreventStore = (arg_doPreventStore); \
		eventData.foundAtIndex = (arg_foundAtIndex); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS(hookInterface, arg_currentThread, arg_classloader, arg_j9module, arg_className, arg_classNameLength, arg_classPathEntries, arg_entryCount, arg_confirmedCount, arg_partition, arg_doPreventFind, arg_doPreventStore, arg_foundAtIndex, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS(hookInterface, arg_currentThread, arg_classloader, arg_j9module, arg_className, arg_classNameLength, arg_classPathEntries, arg_entryCount, arg_confirmedCount, arg_partition, arg_doPreventFind, arg_doPreventStore, arg_foundAtIndex, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_FRAME_POP(hookInterface, arg_currentThread, arg_method, arg_poppedByException) \
	do { \
		struct J9VMFramePopEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.poppedByException = (arg_poppedByException); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FRAME_POP, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_FRAME_POP(hookInterface, arg_currentThread, arg_method, arg_poppedByException) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FRAME_POP)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FRAME_POP(hookInterface, arg_currentThread, arg_method, arg_poppedByException); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_INTERNAL_CLASS_LOAD(hookInterface, arg_currentThread, arg_clazz, arg_failed) \
	do { \
		struct J9VMInternalClassLoadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		eventData.failed = (arg_failed); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_INTERNAL_CLASS_LOAD, &eventData); \
		(arg_failed) = eventData.failed; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_INTERNAL_CLASS_LOAD(hookInterface, arg_currentThread, arg_clazz, arg_failed) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_INTERNAL_CLASS_LOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_INTERNAL_CLASS_LOAD(hookInterface, arg_currentThread, arg_clazz, arg_failed); \
		} \
	} while (0)

#if defined (J9VM_INTERP_HOT_CODE_REPLACEMENT)
#define ALWAYS_TRIGGER_J9HOOK_VM_POP_FRAMES_INTERRUPT(hookInterface, arg_currentThread, arg_executeAsyncCheck) \
	do { \
		struct J9VMPopFramesInterruptEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.executeAsyncCheck = (arg_executeAsyncCheck); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_POP_FRAMES_INTERRUPT, &eventData); \
		(arg_executeAsyncCheck) = eventData.executeAsyncCheck; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_POP_FRAMES_INTERRUPT(hookInterface, arg_currentThread, arg_executeAsyncCheck) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_POP_FRAMES_INTERRUPT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_POP_FRAMES_INTERRUPT(hookInterface, arg_currentThread, arg_executeAsyncCheck); \
		} \
	} while (0)
#else /* defined (J9VM_INTERP_HOT_CODE_REPLACEMENT) */
#define TRIGGER_J9HOOK_VM_POP_FRAMES_INTERRUPT(hookInterface, arg_currentThread, arg_executeAsyncCheck)
#endif /* defined (J9VM_INTERP_HOT_CODE_REPLACEMENT) */

#if defined (J9VM_OPT_JVMTI)
#define ALWAYS_TRIGGER_J9HOOK_VM_LOOKUP_NATIVE_ADDRESS(hookInterface, arg_currentThread, arg_nativeMethod, arg_longJNI, arg_shortJNI, arg_functionArgCount, arg_callback) \
	do { \
		struct J9VMLookupNativeAddressEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.nativeMethod = (arg_nativeMethod); \
		eventData.longJNI = (arg_longJNI); \
		eventData.shortJNI = (arg_shortJNI); \
		eventData.functionArgCount = (arg_functionArgCount); \
		eventData.callback = (arg_callback); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_LOOKUP_NATIVE_ADDRESS, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_LOOKUP_NATIVE_ADDRESS(hookInterface, arg_currentThread, arg_nativeMethod, arg_longJNI, arg_shortJNI, arg_functionArgCount, arg_callback) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_LOOKUP_NATIVE_ADDRESS)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_LOOKUP_NATIVE_ADDRESS(hookInterface, arg_currentThread, arg_nativeMethod, arg_longJNI, arg_shortJNI, arg_functionArgCount, arg_callback); \
		} \
	} while (0)
#else /* defined (J9VM_OPT_JVMTI) */
#define TRIGGER_J9HOOK_VM_LOOKUP_NATIVE_ADDRESS(hookInterface, arg_currentThread, arg_nativeMethod, arg_longJNI, arg_shortJNI, arg_functionArgCount, arg_callback)
#endif /* defined (J9VM_OPT_JVMTI) */

#if defined (J9VM_OPT_JVMTI)
#define ALWAYS_TRIGGER_J9HOOK_VM_FIND_NATIVE_TO_REGISTER(hookInterface, arg_currentThread, arg_method) \
	do { \
		struct J9VMFindNativeToRegisterEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FIND_NATIVE_TO_REGISTER, &eventData); \
		(arg_method) = eventData.method; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_FIND_NATIVE_TO_REGISTER(hookInterface, arg_currentThread, arg_method) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FIND_NATIVE_TO_REGISTER)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FIND_NATIVE_TO_REGISTER(hookInterface, arg_currentThread, arg_method); \
		} \
	} while (0)
#else /* defined (J9VM_OPT_JVMTI) */
#define TRIGGER_J9HOOK_VM_FIND_NATIVE_TO_REGISTER(hookInterface, arg_currentThread, arg_method)
#endif /* defined (J9VM_OPT_JVMTI) */

#if defined (J9VM_OPT_JVMTI)
#define ALWAYS_TRIGGER_J9HOOK_VM_JNI_NATIVE_BIND(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress) \
	do { \
		struct J9VMJNINativeBindEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.nativeMethod = (arg_nativeMethod); \
		eventData.nativeMethodAddress = (arg_nativeMethodAddress); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_JNI_NATIVE_BIND, &eventData); \
		(arg_nativeMethodAddress) = eventData.nativeMethodAddress; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_JNI_NATIVE_BIND(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_JNI_NATIVE_BIND)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_JNI_NATIVE_BIND(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress); \
		} \
	} while (0)
#else /* defined (J9VM_OPT_JVMTI) */
#define TRIGGER_J9HOOK_VM_JNI_NATIVE_BIND(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress)
#endif /* defined (J9VM_OPT_JVMTI) */

#define ALWAYS_TRIGGER_J9HOOK_VM_JNI_NATIVE_REGISTERED(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress) \
	do { \
		struct J9VMJNINativeRegisteredEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.nativeMethod = (arg_nativeMethod); \
		eventData.nativeMethodAddress = (arg_nativeMethodAddress); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_JNI_NATIVE_REGISTERED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_JNI_NATIVE_REGISTERED(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_JNI_NATIVE_REGISTERED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_JNI_NATIVE_REGISTERED(hookInterface, arg_currentThread, arg_nativeMethod, arg_nativeMethodAddress); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZE_REQUIRED_CLASSES_DONE(hookInterface, arg_currentThread, arg_continueInitialization) \
	do { \
		struct J9VMInitializeRequiredClassesDoneEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.continueInitialization = (arg_continueInitialization); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_INITIALIZE_REQUIRED_CLASSES_DONE, &eventData); \
		(arg_continueInitialization) = eventData.continueInitialization; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_INITIALIZE_REQUIRED_CLASSES_DONE(hookInterface, arg_currentThread, arg_continueInitialization) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_INITIALIZE_REQUIRED_CLASSES_DONE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZE_REQUIRED_CLASSES_DONE(hookInterface, arg_currentThread, arg_continueInitialization); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZE_TENANTDATA_DONE(hookInterface, arg_currentThread) \
	do { \
		struct J9VMInitializeTenantDataDoneEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_INITIALIZE_TENANTDATA_DONE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_INITIALIZE_TENANTDATA_DONE(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_INITIALIZE_TENANTDATA_DONE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_INITIALIZE_TENANTDATA_DONE(hookInterface, arg_currentThread); \
		} \
	} while (0)

#if defined (J9VM_INTERP_NATIVE_SUPPORT)
#define ALWAYS_TRIGGER_J9HOOK_VM_DYNAMIC_CODE_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_name, arg_metaData) \
	do { \
		struct J9DynamicCodeLoadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.startPC = (arg_startPC); \
		eventData.length = (arg_length); \
		eventData.name = (arg_name); \
		eventData.metaData = (arg_metaData); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_DYNAMIC_CODE_LOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_DYNAMIC_CODE_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_name, arg_metaData) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_DYNAMIC_CODE_LOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_DYNAMIC_CODE_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_name, arg_metaData); \
		} \
	} while (0)
#else /* defined (J9VM_INTERP_NATIVE_SUPPORT) */
#define TRIGGER_J9HOOK_VM_DYNAMIC_CODE_LOAD(hookInterface, arg_currentThread, arg_method, arg_startPC, arg_length, arg_name, arg_metaData)
#endif /* defined (J9VM_INTERP_NATIVE_SUPPORT) */

#if defined (J9VM_INTERP_NATIVE_SUPPORT)
#define ALWAYS_TRIGGER_J9HOOK_VM_DYNAMIC_CODE_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC) \
	do { \
		struct J9DynamicCodeUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.method = (arg_method); \
		eventData.startPC = (arg_startPC); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_DYNAMIC_CODE_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_DYNAMIC_CODE_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_DYNAMIC_CODE_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_DYNAMIC_CODE_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC); \
		} \
	} while (0)
#else /* defined (J9VM_INTERP_NATIVE_SUPPORT) */
#define TRIGGER_J9HOOK_VM_DYNAMIC_CODE_UNLOAD(hookInterface, arg_currentThread, arg_method, arg_startPC)
#endif /* defined (J9VM_INTERP_NATIVE_SUPPORT) */

#if defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING)
#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_UNLOAD(hookInterface, arg_currentThread, arg_classLoader) \
	do { \
		struct J9VMClassLoaderUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classLoader = (arg_classLoader); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADER_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADER_UNLOAD(hookInterface, arg_currentThread, arg_classLoader) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADER_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_UNLOAD(hookInterface, arg_currentThread, arg_classLoader); \
		} \
	} while (0)
#else /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */
#define TRIGGER_J9HOOK_VM_CLASS_LOADER_UNLOAD(hookInterface, arg_currentThread, arg_classLoader)
#endif /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */

#if defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING)
#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADERS_UNLOAD(hookInterface, arg_currentThread, arg_classLoadersToUnload) \
	do { \
		struct J9VMClassLoadersUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classLoadersToUnload = (arg_classLoadersToUnload); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADERS_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADERS_UNLOAD(hookInterface, arg_currentThread, arg_classLoadersToUnload) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADERS_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADERS_UNLOAD(hookInterface, arg_currentThread, arg_classLoadersToUnload); \
		} \
	} while (0)
#else /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */
#define TRIGGER_J9HOOK_VM_CLASS_LOADERS_UNLOAD(hookInterface, arg_currentThread, arg_classLoadersToUnload)
#endif /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */

#if defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING)
#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_UNLOAD(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		struct J9VMClassUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.clazz = (arg_clazz); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_UNLOAD(hookInterface, arg_currentThread, arg_clazz) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_UNLOAD(hookInterface, arg_currentThread, arg_clazz); \
		} \
	} while (0)
#else /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */
#define TRIGGER_J9HOOK_VM_CLASS_UNLOAD(hookInterface, arg_currentThread, arg_clazz)
#endif /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */

#if defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING)
#define ALWAYS_TRIGGER_J9HOOK_VM_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_classUnloadCount, arg_classesToUnload) \
	do { \
		struct J9VMClassesUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classUnloadCount = (arg_classUnloadCount); \
		eventData.classesToUnload = (arg_classesToUnload); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASSES_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_classUnloadCount, arg_classesToUnload) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASSES_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_classUnloadCount, arg_classesToUnload); \
		} \
	} while (0)
#else /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */
#define TRIGGER_J9HOOK_VM_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_classUnloadCount, arg_classesToUnload)
#endif /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */

#if defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING)
#define ALWAYS_TRIGGER_J9HOOK_VM_ANON_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_anonymousClassUnloadCount, arg_anonymousClassesToUnload) \
	do { \
		struct J9VMAnonymousClassesUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.anonymousClassUnloadCount = (arg_anonymousClassUnloadCount); \
		eventData.anonymousClassesToUnload = (arg_anonymousClassesToUnload); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_ANON_CLASSES_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_ANON_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_anonymousClassUnloadCount, arg_anonymousClassesToUnload) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_ANON_CLASSES_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_ANON_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_anonymousClassUnloadCount, arg_anonymousClassesToUnload); \
		} \
	} while (0)
#else /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */
#define TRIGGER_J9HOOK_VM_ANON_CLASSES_UNLOAD(hookInterface, arg_currentThread, arg_anonymousClassUnloadCount, arg_anonymousClassesToUnload)
#endif /* defined (J9VM_GC_DYNAMIC_CLASS_UNLOADING) */

#define ALWAYS_TRIGGER_J9HOOK_VM_STORE_COMPILED_METHOD(hookInterface, arg_currentThread, arg_romMethod, arg_dataStart, arg_dataSize, arg_codeStart, arg_codeSize, arg_result) \
	do { \
		struct J9VMStoreCompiledMethodEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.romMethod = (arg_romMethod); \
		eventData.dataStart = (arg_dataStart); \
		eventData.dataSize = (arg_dataSize); \
		eventData.codeStart = (arg_codeStart); \
		eventData.codeSize = (arg_codeSize); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_STORE_COMPILED_METHOD, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_STORE_COMPILED_METHOD(hookInterface, arg_currentThread, arg_romMethod, arg_dataStart, arg_dataSize, arg_codeStart, arg_codeSize, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_STORE_COMPILED_METHOD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_STORE_COMPILED_METHOD(hookInterface, arg_currentThread, arg_romMethod, arg_dataStart, arg_dataSize, arg_codeStart, arg_codeSize, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_FIND_COMPILED_METHOD(hookInterface, arg_currentThread, arg_romMethod, arg_result) \
	do { \
		struct J9VMFindCompiledMethodEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.romMethod = (arg_romMethod); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FIND_COMPILED_METHOD, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_FIND_COMPILED_METHOD(hookInterface, arg_currentThread, arg_romMethod, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FIND_COMPILED_METHOD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FIND_COMPILED_METHOD(hookInterface, arg_currentThread, arg_romMethod, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_DUMP_START(hookInterface, arg_currentThread, arg_label, arg_detail) \
	do { \
		struct J9VMVmDumpStartEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.label = (arg_label); \
		eventData.detail = (arg_detail); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_DUMP_START, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_DUMP_START(hookInterface, arg_currentThread, arg_label, arg_detail) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_DUMP_START)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_DUMP_START(hookInterface, arg_currentThread, arg_label, arg_detail); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_DUMP_END(hookInterface, arg_currentThread, arg_label, arg_detail) \
	do { \
		struct J9VMVmDumpEndEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.label = (arg_label); \
		eventData.detail = (arg_detail); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_DUMP_END, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_DUMP_END(hookInterface, arg_currentThread, arg_label, arg_detail) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_DUMP_END)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_DUMP_END(hookInterface, arg_currentThread, arg_label, arg_detail); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_RESOURCE_EXHAUSTED(hookInterface, arg_currentThread, arg_resourceTypes, arg_description) \
	do { \
		struct J9VMVmResourceExhaustedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.resourceTypes = (arg_resourceTypes); \
		eventData.description = (arg_description); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_RESOURCE_EXHAUSTED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_RESOURCE_EXHAUSTED(hookInterface, arg_currentThread, arg_resourceTypes, arg_description) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_RESOURCE_EXHAUSTED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_RESOURCE_EXHAUSTED(hookInterface, arg_currentThread, arg_resourceTypes, arg_description); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_LOAD_JNI_LIBRARY(hookInterface, arg_currentThread, arg_classLoader, arg_logicalName, arg_nativeLibrary, arg_result, arg_errorBuf, arg_bufLen, arg_openFlags) \
	do { \
		struct J9VMLoadJNILibraryEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.classLoader = (arg_classLoader); \
		eventData.logicalName = (arg_logicalName); \
		eventData.nativeLibrary = (arg_nativeLibrary); \
		eventData.result = (arg_result); \
		eventData.errorBuf = (arg_errorBuf); \
		eventData.bufLen = (arg_bufLen); \
		eventData.openFlags = (arg_openFlags); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_LOAD_JNI_LIBRARY, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_LOAD_JNI_LIBRARY(hookInterface, arg_currentThread, arg_classLoader, arg_logicalName, arg_nativeLibrary, arg_result, arg_errorBuf, arg_bufLen, arg_openFlags) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_LOAD_JNI_LIBRARY)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_LOAD_JNI_LIBRARY(hookInterface, arg_currentThread, arg_classLoader, arg_logicalName, arg_nativeLibrary, arg_result, arg_errorBuf, arg_bufLen, arg_openFlags); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SERIALIZE_SHARED_CACHE(hookInterface, arg_vm, arg_result) \
	do { \
		struct J9VMSerializeSharedCacheEvent eventData; \
		eventData.vm = (arg_vm); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SERIALIZE_SHARED_CACHE, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_SERIALIZE_SHARED_CACHE(hookInterface, arg_vm, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_SERIALIZE_SHARED_CACHE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_SERIALIZE_SHARED_CACHE(hookInterface, arg_vm, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_CREATED(hookInterface, arg_vm, arg_classLoader) \
	do { \
		struct J9VMClassloaderCreatedEvent eventData; \
		eventData.vm = (arg_vm); \
		eventData.classLoader = (arg_classLoader); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADER_CREATED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADER_CREATED(hookInterface, arg_vm, arg_classLoader) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADER_CREATED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_CREATED(hookInterface, arg_vm, arg_classLoader); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_DESTROY(hookInterface, arg_vm, arg_classLoader) \
	do { \
		struct J9VMClassloaderDestroyEvent eventData; \
		eventData.vm = (arg_vm); \
		eventData.classLoader = (arg_classLoader); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADER_DESTROY, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADER_DESTROY(hookInterface, arg_vm, arg_classLoader) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADER_DESTROY)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_DESTROY(hookInterface, arg_vm, arg_classLoader); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRY_ADDED(hookInterface, arg_vm, arg_classLoader, arg_classPathEntry) \
	do { \
		struct J9VMClassloaderClassPathEntryAddedEvent eventData; \
		eventData.vm = (arg_vm); \
		eventData.classLoader = (arg_classLoader); \
		eventData.classPathEntry = (arg_classPathEntry); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRY_ADDED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRY_ADDED(hookInterface, arg_vm, arg_classLoader, arg_classPathEntry) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRY_ADDED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRY_ADDED(hookInterface, arg_vm, arg_classLoader, arg_classPathEntry); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRIES_INITIALIZED(hookInterface, arg_vm, arg_classLoader) \
	do { \
		struct J9VMClassloaderClassPathEntriesInitializedEvent eventData; \
		eventData.vm = (arg_vm); \
		eventData.classLoader = (arg_classLoader); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRIES_INITIALIZED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRIES_INITIALIZED(hookInterface, arg_vm, arg_classLoader) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRIES_INITIALIZED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_LOADER_CLASSPATH_ENTRIES_INITIALIZED(hookInterface, arg_vm, arg_classLoader); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS_FROM_FILESYSTEM(hookInterface, arg_currentThread, arg_className, arg_classNameLength, arg_classloader, arg_classFound, arg_result) \
	do { \
		struct J9VMFindLocalClassFromFilesystemEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.className = (arg_className); \
		eventData.classNameLength = (arg_classNameLength); \
		eventData.classloader = (arg_classloader); \
		eventData.classFound = (arg_classFound); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS_FROM_FILESYSTEM, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS_FROM_FILESYSTEM(hookInterface, arg_currentThread, arg_className, arg_classNameLength, arg_classloader, arg_classFound, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS_FROM_FILESYSTEM)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_FIND_LOCALLY_DEFINED_CLASS_FROM_FILESYSTEM(hookInterface, arg_currentThread, arg_className, arg_classNameLength, arg_classloader, arg_classFound, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SCAR_PRECONFIGURE(hookInterface, arg_vm, arg_returnValue, arg_result) \
	do { \
		struct J9VMScarPreconfigureEvent eventData; \
		eventData.vm = (arg_vm); \
		eventData.returnValue = (arg_returnValue); \
		eventData.result = (arg_result); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SCAR_PRECONFIGURE, &eventData); \
		(arg_result) = eventData.result; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_SCAR_PRECONFIGURE(hookInterface, arg_vm, arg_returnValue, arg_result) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_SCAR_PRECONFIGURE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_SCAR_PRECONFIGURE(hookInterface, arg_vm, arg_returnValue, arg_result); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE_WITHIN_THRESHOLD(hookInterface, arg_currentThread, arg_object, arg_size, arg_lowThreshold, arg_highThreshold) \
	do { \
		struct J9VMAllocationThresholdEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.object = (arg_object); \
		eventData.size = (arg_size); \
		eventData.lowThreshold = (arg_lowThreshold); \
		eventData.highThreshold = (arg_highThreshold); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_OBJECT_ALLOCATE_WITHIN_THRESHOLD, &eventData); \
		(arg_object) = eventData.object; /* return argument */ \
	} while (0)

#define TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE_WITHIN_THRESHOLD(hookInterface, arg_currentThread, arg_object, arg_size, arg_lowThreshold, arg_highThreshold) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_OBJECT_ALLOCATE_WITHIN_THRESHOLD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_OBJECT_ALLOCATE_WITHIN_THRESHOLD(hookInterface, arg_currentThread, arg_object, arg_size, arg_lowThreshold, arg_highThreshold); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SLEEP(hookInterface, arg_currentThread, arg_millis, arg_nanos) \
	do { \
		struct J9VMSleepEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.millis = (arg_millis); \
		eventData.nanos = (arg_nanos); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SLEEP, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_SLEEP(hookInterface, arg_currentThread, arg_millis, arg_nanos) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_SLEEP)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_SLEEP(hookInterface, arg_currentThread, arg_millis, arg_nanos); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_SLEPT(hookInterface, arg_currentThread, arg_millis, arg_nanos, arg_startTicks) \
	do { \
		struct J9VMSleptEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.millis = (arg_millis); \
		eventData.nanos = (arg_nanos); \
		eventData.startTicks = (arg_startTicks); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_SLEPT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_SLEPT(hookInterface, arg_currentThread, arg_millis, arg_nanos, arg_startTicks) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_SLEPT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_SLEPT(hookInterface, arg_currentThread, arg_millis, arg_nanos, arg_startTicks); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CORRUPT_CACHE(hookInterface, arg_vmThread) \
	do { \
		struct J9VMCorruptCache eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CORRUPT_CACHE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CORRUPT_CACHE(hookInterface, arg_vmThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CORRUPT_CACHE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CORRUPT_CACHE(hookInterface, arg_vmThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASSES_REDEFINED(hookInterface, arg_currentThread) \
	do { \
		struct J9VMClassesRedefinedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASSES_REDEFINED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASSES_REDEFINED(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASSES_REDEFINED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASSES_REDEFINED(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_START(hookInterface, arg_verifyData, arg_newFormat) \
	do { \
		struct J9VMClassVerificationStartEvent eventData; \
		eventData.verifyData = (arg_verifyData); \
		eventData.newFormat = (arg_newFormat); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_VERIFICATION_START, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_START(hookInterface, arg_verifyData, arg_newFormat) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_VERIFICATION_START)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_START(hookInterface, arg_verifyData, arg_newFormat); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_FALLBACK(hookInterface, arg_verifyData, arg_newFormat) \
	do { \
		struct J9VMMethodVerificationEndEvent eventData; \
		eventData.verifyData = (arg_verifyData); \
		eventData.newFormat = (arg_newFormat); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_VERIFICATION_FALLBACK, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_FALLBACK(hookInterface, arg_verifyData, arg_newFormat) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_VERIFICATION_FALLBACK)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_FALLBACK(hookInterface, arg_verifyData, arg_newFormat); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_END(hookInterface, arg_verifyData, arg_newFormat) \
	do { \
		struct J9VMClassVerificationEndEvent eventData; \
		eventData.verifyData = (arg_verifyData); \
		eventData.newFormat = (arg_newFormat); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CLASS_VERIFICATION_END, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_END(hookInterface, arg_verifyData, arg_newFormat) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CLASS_VERIFICATION_END)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CLASS_VERIFICATION_END(hookInterface, arg_verifyData, arg_newFormat); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_METHOD_VERIFICATION_START(hookInterface, arg_verifyData) \
	do { \
		struct J9VMMethodVerificationStartEvent eventData; \
		eventData.verifyData = (arg_verifyData); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_METHOD_VERIFICATION_START, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_METHOD_VERIFICATION_START(hookInterface, arg_verifyData) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_METHOD_VERIFICATION_START)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_METHOD_VERIFICATION_START(hookInterface, arg_verifyData); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_STACKMAPFRAME_VERIFICATION(hookInterface, arg_verifyData) \
	do { \
		struct J9VMStackMapFrameVerificationEvent eventData; \
		eventData.verifyData = (arg_verifyData); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_STACKMAPFRAME_VERIFICATION, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_STACKMAPFRAME_VERIFICATION(hookInterface, arg_verifyData) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_STACKMAPFRAME_VERIFICATION)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_STACKMAPFRAME_VERIFICATION(hookInterface, arg_verifyData); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_JAVA_BASE_LOADED(hookInterface, arg_vmThread) \
	do { \
		struct J9VMModuleStartEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_JAVA_BASE_LOADED | J9HOOK_TAG_ONCE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_JAVA_BASE_LOADED(hookInterface, arg_vmThread) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_JAVA_BASE_LOADED(hookInterface, arg_vmThread); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_DEEP_IDLE_STATE_ENTERED(hookInterface, arg_vmThread, arg_level) \
	do { \
		struct J9VMDeepIdleStateEnteredEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		eventData.level = (arg_level); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_DEEP_IDLE_STATE_ENTERED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_DEEP_IDLE_STATE_ENTERED(hookInterface, arg_vmThread, arg_level) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_DEEP_IDLE_STATE_ENTERED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_DEEP_IDLE_STATE_ENTERED(hookInterface, arg_vmThread, arg_level); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_RUNTIME_STATE_CHANGED(hookInterface, arg_vmThread, arg_state) \
	do { \
		struct J9VMRuntimeStateChanged eventData; \
		eventData.vmThread = (arg_vmThread); \
		eventData.state = (arg_state); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_RUNTIME_STATE_CHANGED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_RUNTIME_STATE_CHANGED(hookInterface, arg_vmThread, arg_state) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_RUNTIME_STATE_CHANGED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_RUNTIME_STATE_CHANGED(hookInterface, arg_vmThread, arg_state); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MODULE_LOAD(hookInterface, arg_currentThread, arg_module) \
	do { \
		struct J9VMModuleLoadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.module = (arg_module); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MODULE_LOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MODULE_LOAD(hookInterface, arg_currentThread, arg_module) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MODULE_LOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MODULE_LOAD(hookInterface, arg_currentThread, arg_module); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_MODULE_UNLOAD(hookInterface, arg_currentThread, arg_module) \
	do { \
		struct J9VMModuleUnloadEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		eventData.module = (arg_module); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_MODULE_UNLOAD, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_MODULE_UNLOAD(hookInterface, arg_currentThread, arg_module) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_MODULE_UNLOAD)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_MODULE_UNLOAD(hookInterface, arg_currentThread, arg_module); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_PREPARING_FOR_CHECKPOINT(hookInterface, arg_currentThread) \
	do { \
		struct J9CheckpointEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PREPARING_FOR_CHECKPOINT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_PREPARING_FOR_CHECKPOINT(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PREPARING_FOR_CHECKPOINT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PREPARING_FOR_CHECKPOINT(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_PREPARING_FOR_RESTORE(hookInterface, arg_currentThread) \
	do { \
		struct J9RestoreEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_PREPARING_FOR_RESTORE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_PREPARING_FOR_RESTORE(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_PREPARING_FOR_RESTORE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_PREPARING_FOR_RESTORE(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_STARTED(hookInterface, arg_currentThread) \
	do { \
		struct J9VirtualThreadStartedEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_VIRTUAL_THREAD_STARTED, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_STARTED(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_VIRTUAL_THREAD_STARTED)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_STARTED(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_END(hookInterface, arg_currentThread) \
	do { \
		struct J9VirtualThreadEndEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_VIRTUAL_THREAD_END, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_END(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_VIRTUAL_THREAD_END)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_END(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_MOUNT(hookInterface, arg_currentThread) \
	do { \
		struct J9VMVirtualThreadMountEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_VIRTUAL_THREAD_MOUNT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_MOUNT(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_VIRTUAL_THREAD_MOUNT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_MOUNT(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_UNMOUNT(hookInterface, arg_currentThread) \
	do { \
		struct J9VMVirtualThreadUnmountEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_VIRTUAL_THREAD_UNMOUNT, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_UNMOUNT(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_VIRTUAL_THREAD_UNMOUNT)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_UNMOUNT(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_DESTROY(hookInterface, arg_currentThread) \
	do { \
		struct J9VMVirtualThreadDestroyEvent eventData; \
		eventData.currentThread = (arg_currentThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_VIRTUAL_THREAD_DESTROY, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_DESTROY(hookInterface, arg_currentThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_VIRTUAL_THREAD_DESTROY)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_VIRTUAL_THREAD_DESTROY(hookInterface, arg_currentThread); \
		} \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CRIU_CHECKPOINT(hookInterface, arg_vmThread) \
	do { \
		struct J9VMCRIUCheckpointEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CRIU_CHECKPOINT | J9HOOK_TAG_ONCE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CRIU_CHECKPOINT(hookInterface, arg_vmThread) \
	do { \
		/* always trigger this 'report once' event, so that it will be disabled after this point */ \
			ALWAYS_TRIGGER_J9HOOK_VM_CRIU_CHECKPOINT(hookInterface, arg_vmThread); \
	} while (0)

#define ALWAYS_TRIGGER_J9HOOK_VM_CRIU_RESTORE(hookInterface, arg_vmThread) \
	do { \
		struct J9VMCRIURestoreEvent eventData; \
		eventData.vmThread = (arg_vmThread); \
		(*J9_HOOK_INTERFACE(hookInterface))->J9HookDispatch(J9_HOOK_INTERFACE(hookInterface), J9HOOK_VM_CRIU_RESTORE, &eventData); \
	} while (0)

#define TRIGGER_J9HOOK_VM_CRIU_RESTORE(hookInterface, arg_vmThread) \
	do { \
		if (J9_EVENT_IS_HOOKED(hookInterface, J9HOOK_VM_CRIU_RESTORE)) { \
			ALWAYS_TRIGGER_J9HOOK_VM_CRIU_RESTORE(hookInterface, arg_vmThread); \
		} \
	} while (0)

typedef struct J9VMHookInterface {
	struct J9CommonHookInterface common;
	U_8 flags[111];
	struct OMREventInfo4Dump infos4Dump[111];
	J9HookRecord* hooks[111];
} J9VMHookInterface;

#endif /* VMHOOK_INTERNAL_H */
